diff -ru PyWebDAV-0.9~/DAV/WebDAVServer.py PyWebDAV-0.9/DAV/WebDAVServer.py
--- PyWebDAV-0.9~/DAV/WebDAVServer.py	2009-05-06 12:00:44.000000000 +0200
+++ PyWebDAV-0.9/DAV/WebDAVServer.py	2009-05-06 12:18:12.000000000 +0200
@@ -177,7 +177,7 @@
         else:
             d="infinity"
 
-        uri=urlparse.urljoin(dc.baseuri,self.path)
+        uri=urlparse.urljoin(self.get_baseuri(dc), self.path)
         uri=urllib.unquote(uri)
         pf=PROPFIND(uri,dc,d)
 
@@ -206,7 +206,7 @@
         """Serve a GET request."""
 
         dc=self.IFACE_CLASS
-        uri=urlparse.urljoin(dc.baseuri,self.path)
+        uri=urlparse.urljoin(self.get_baseuri(dc), self.path)
         uri=urllib.unquote(uri)
 
         # get the last modified date
@@ -243,7 +243,7 @@
         """ Send a HEAD response """
 
         dc=self.IFACE_CLASS
-        uri=urlparse.urljoin(dc.baseuri,self.path)
+        uri=urlparse.urljoin(self.get_baseuri(dc), self.path)
         uri=urllib.unquote(uri)
 
         # get the last modified date
@@ -283,7 +283,7 @@
         """ create a new collection """
 
         dc=self.IFACE_CLASS
-        uri=urlparse.urljoin(dc.baseuri,self.path)
+        uri=urlparse.urljoin(self.get_baseuri(dc), self.path)
         uri=urllib.unquote(uri)
         try:
             dc.mkcol(uri)
@@ -294,7 +294,7 @@
     def do_DELETE(self):
         """ delete an resource """
         dc=self.IFACE_CLASS
-        uri=urlparse.urljoin(dc.baseuri,self.path)
+        uri=urlparse.urljoin(self.get_baseuri(dc), self.path)
         uri=urllib.unquote(uri)
         dl=DELETE(uri,dc)
         if dc.is_collection(uri):
@@ -323,7 +323,7 @@
         if self.headers.has_key("Content-Length"):
             l=self.headers['Content-Length']
             body=self.rfile.read(atoi(l))
-        uri=urlparse.urljoin(dc.baseuri,self.path)
+        uri=urlparse.urljoin(self.get_baseuri(dc), self.path)
         uri=urllib.unquote(uri)
 
         ct=None
@@ -365,7 +365,7 @@
         dc=self.IFACE_CLASS
 
         # get the source URI
-        source_uri=urlparse.urljoin(dc.baseuri,self.path)
+        source_uri=urlparse.urljoin(self.get_baseuri(dc),self.path)
         source_uri=urllib.unquote(source_uri)
 
         # get the destination URI
@@ -429,3 +429,10 @@
         if not msg: msg=self.responses[code][1]
         self.send_body(body,code,self.responses[code][0],msg,mediatype)
 
+    def get_baseuri(self, dc):
+        baseuri = dc.baseuri
+        if self.headers.has_key('Host'):
+            uparts = list(urlparse.urlparse(dc.baseuri))
+            uparts[1] = self.headers['Host']
+            baseuri = urlparse.urlunparse(uparts)
+        return baseuri
